/*
 * This header file contains inclusions for the main definitions and for
 * any DEPENDS UPON modules.  It also contains #define commands to open
 * the scope of the main definitons module.
 *
 * main inclusion:
 */
#include "Clearinghouse2.h"

/* DEPENDS UPON BulkData NUMBER 0 VERSION 1 */
/* DEPENDS UPON Authentication NUMBER 14 VERSION 1 */
/*
 * Widen scope to include all symbols defined in main inclusion:
 */
typedef Clearinghouse2_Organization Organization;
#define sizeof_Organization sizeof_Clearinghouse2_Organization
#define clear_Organization clear_Clearinghouse2_Organization
#define externalize_Organization externalize_Clearinghouse2_Organization
#define internalize_Organization internalize_Clearinghouse2_Organization

typedef Clearinghouse2_Domain Domain;
#define sizeof_Domain sizeof_Clearinghouse2_Domain
#define clear_Domain clear_Clearinghouse2_Domain
#define externalize_Domain externalize_Clearinghouse2_Domain
#define internalize_Domain internalize_Clearinghouse2_Domain

typedef Clearinghouse2_Object Object;
#define sizeof_Object sizeof_Clearinghouse2_Object
#define clear_Object clear_Clearinghouse2_Object
#define externalize_Object externalize_Clearinghouse2_Object
#define internalize_Object internalize_Clearinghouse2_Object

#define maxOrganizationsLength Clearinghouse2_maxOrganizationsLength
#define maxDomainLength Clearinghouse2_maxDomainLength
#define maxObjectLength Clearinghouse2_maxObjectLength
typedef Clearinghouse2_OrganizationName OrganizationName;
#define sizeof_OrganizationName sizeof_Clearinghouse2_OrganizationName
#define clear_OrganizationName clear_Clearinghouse2_OrganizationName
#define externalize_OrganizationName externalize_Clearinghouse2_OrganizationName
#define internalize_OrganizationName internalize_Clearinghouse2_OrganizationName

typedef Clearinghouse2_TwoPartName TwoPartName;
#define sizeof_TwoPartName sizeof_Clearinghouse2_TwoPartName
#define clear_TwoPartName clear_Clearinghouse2_TwoPartName
#define externalize_TwoPartName externalize_Clearinghouse2_TwoPartName
#define internalize_TwoPartName internalize_Clearinghouse2_TwoPartName

typedef Clearinghouse2_DomainName DomainName;
#define sizeof_DomainName sizeof_Clearinghouse2_DomainName
#define clear_DomainName clear_Clearinghouse2_DomainName
#define externalize_DomainName externalize_Clearinghouse2_DomainName
#define internalize_DomainName internalize_Clearinghouse2_DomainName

typedef Clearinghouse2_ThreePartName ThreePartName;
#define sizeof_ThreePartName sizeof_Clearinghouse2_ThreePartName
#define clear_ThreePartName clear_Clearinghouse2_ThreePartName
#define externalize_ThreePartName externalize_Clearinghouse2_ThreePartName
#define internalize_ThreePartName internalize_Clearinghouse2_ThreePartName

typedef Clearinghouse2_ObjectName ObjectName;
#define sizeof_ObjectName sizeof_Clearinghouse2_ObjectName
#define clear_ObjectName clear_Clearinghouse2_ObjectName
#define externalize_ObjectName externalize_Clearinghouse2_ObjectName
#define internalize_ObjectName internalize_Clearinghouse2_ObjectName

typedef Clearinghouse2_Name Name;
#define sizeof_Name sizeof_Clearinghouse2_Name
#define clear_Name clear_Clearinghouse2_Name
#define externalize_Name externalize_Clearinghouse2_Name
#define internalize_Name internalize_Clearinghouse2_Name

typedef Clearinghouse2_OrganizationNamePattern OrganizationNamePattern;
#define sizeof_OrganizationNamePattern sizeof_Clearinghouse2_OrganizationNamePattern
#define clear_OrganizationNamePattern clear_Clearinghouse2_OrganizationNamePattern
#define externalize_OrganizationNamePattern externalize_Clearinghouse2_OrganizationNamePattern
#define internalize_OrganizationNamePattern internalize_Clearinghouse2_OrganizationNamePattern

typedef Clearinghouse2_DomainNamePattern DomainNamePattern;
#define sizeof_DomainNamePattern sizeof_Clearinghouse2_DomainNamePattern
#define clear_DomainNamePattern clear_Clearinghouse2_DomainNamePattern
#define externalize_DomainNamePattern externalize_Clearinghouse2_DomainNamePattern
#define internalize_DomainNamePattern internalize_Clearinghouse2_DomainNamePattern

typedef Clearinghouse2_ObjectNamePattern ObjectNamePattern;
#define sizeof_ObjectNamePattern sizeof_Clearinghouse2_ObjectNamePattern
#define clear_ObjectNamePattern clear_Clearinghouse2_ObjectNamePattern
#define externalize_ObjectNamePattern externalize_Clearinghouse2_ObjectNamePattern
#define internalize_ObjectNamePattern internalize_Clearinghouse2_ObjectNamePattern

typedef Clearinghouse2_T_r2_9 T_r2_9;
#define sizeof_T_r2_9 sizeof_Clearinghouse2_T_r2_9
#define clear_T_r2_9 clear_Clearinghouse2_T_r2_9
#define externalize_T_r2_9 externalize_Clearinghouse2_T_r2_9
#define internalize_T_r2_9 internalize_Clearinghouse2_T_r2_9

typedef Clearinghouse2_T_c2_8 T_c2_8;
#define sizeof_T_c2_8 sizeof_Clearinghouse2_T_c2_8
#define clear_T_c2_8 clear_Clearinghouse2_T_c2_8
#define externalize_T_c2_8 externalize_Clearinghouse2_T_c2_8
#define internalize_T_c2_8 internalize_Clearinghouse2_T_c2_8

typedef Clearinghouse2_T_c2_10 T_c2_10;
#define sizeof_T_c2_10 sizeof_Clearinghouse2_T_c2_10
#define clear_T_c2_10 clear_Clearinghouse2_T_c2_10
#define externalize_T_c2_10 externalize_Clearinghouse2_T_c2_10
#define internalize_T_c2_10 internalize_Clearinghouse2_T_c2_10

typedef Clearinghouse2_StreamOfDomain StreamOfDomain;
#define sizeof_StreamOfDomain sizeof_Clearinghouse2_StreamOfDomain
#define clear_StreamOfDomain clear_Clearinghouse2_StreamOfDomain
#define externalize_StreamOfDomain externalize_Clearinghouse2_StreamOfDomain
#define internalize_StreamOfDomain internalize_Clearinghouse2_StreamOfDomain

typedef Clearinghouse2_T_r2_12 T_r2_12;
#define sizeof_T_r2_12 sizeof_Clearinghouse2_T_r2_12
#define clear_T_r2_12 clear_Clearinghouse2_T_r2_12
#define externalize_T_r2_12 externalize_Clearinghouse2_T_r2_12
#define internalize_T_r2_12 internalize_Clearinghouse2_T_r2_12

typedef Clearinghouse2_T_c2_11 T_c2_11;
#define sizeof_T_c2_11 sizeof_Clearinghouse2_T_c2_11
#define clear_T_c2_11 clear_Clearinghouse2_T_c2_11
#define externalize_T_c2_11 externalize_Clearinghouse2_T_c2_11
#define internalize_T_c2_11 internalize_Clearinghouse2_T_c2_11

typedef Clearinghouse2_T_c2_13 T_c2_13;
#define sizeof_T_c2_13 sizeof_Clearinghouse2_T_c2_13
#define clear_T_c2_13 clear_Clearinghouse2_T_c2_13
#define externalize_T_c2_13 externalize_Clearinghouse2_T_c2_13
#define internalize_T_c2_13 internalize_Clearinghouse2_T_c2_13

typedef Clearinghouse2_StreamOfDomainName StreamOfDomainName;
#define sizeof_StreamOfDomainName sizeof_Clearinghouse2_StreamOfDomainName
#define clear_StreamOfDomainName clear_Clearinghouse2_StreamOfDomainName
#define externalize_StreamOfDomainName externalize_Clearinghouse2_StreamOfDomainName
#define internalize_StreamOfDomainName internalize_Clearinghouse2_StreamOfDomainName

typedef Clearinghouse2_T_r2_15 T_r2_15;
#define sizeof_T_r2_15 sizeof_Clearinghouse2_T_r2_15
#define clear_T_r2_15 clear_Clearinghouse2_T_r2_15
#define externalize_T_r2_15 externalize_Clearinghouse2_T_r2_15
#define internalize_T_r2_15 internalize_Clearinghouse2_T_r2_15

typedef Clearinghouse2_T_c2_14 T_c2_14;
#define sizeof_T_c2_14 sizeof_Clearinghouse2_T_c2_14
#define clear_T_c2_14 clear_Clearinghouse2_T_c2_14
#define externalize_T_c2_14 externalize_Clearinghouse2_T_c2_14
#define internalize_T_c2_14 internalize_Clearinghouse2_T_c2_14

typedef Clearinghouse2_T_c2_16 T_c2_16;
#define sizeof_T_c2_16 sizeof_Clearinghouse2_T_c2_16
#define clear_T_c2_16 clear_Clearinghouse2_T_c2_16
#define externalize_T_c2_16 externalize_Clearinghouse2_T_c2_16
#define internalize_T_c2_16 internalize_Clearinghouse2_T_c2_16

typedef Clearinghouse2_StreamOfObject StreamOfObject;
#define sizeof_StreamOfObject sizeof_Clearinghouse2_StreamOfObject
#define clear_StreamOfObject clear_Clearinghouse2_StreamOfObject
#define externalize_StreamOfObject externalize_Clearinghouse2_StreamOfObject
#define internalize_StreamOfObject internalize_Clearinghouse2_StreamOfObject

typedef Clearinghouse2_T_r2_18 T_r2_18;
#define sizeof_T_r2_18 sizeof_Clearinghouse2_T_r2_18
#define clear_T_r2_18 clear_Clearinghouse2_T_r2_18
#define externalize_T_r2_18 externalize_Clearinghouse2_T_r2_18
#define internalize_T_r2_18 internalize_Clearinghouse2_T_r2_18

typedef Clearinghouse2_T_c2_17 T_c2_17;
#define sizeof_T_c2_17 sizeof_Clearinghouse2_T_c2_17
#define clear_T_c2_17 clear_Clearinghouse2_T_c2_17
#define externalize_T_c2_17 externalize_Clearinghouse2_T_c2_17
#define internalize_T_c2_17 internalize_Clearinghouse2_T_c2_17

typedef Clearinghouse2_T_c2_19 T_c2_19;
#define sizeof_T_c2_19 sizeof_Clearinghouse2_T_c2_19
#define clear_T_c2_19 clear_Clearinghouse2_T_c2_19
#define externalize_T_c2_19 externalize_Clearinghouse2_T_c2_19
#define internalize_T_c2_19 internalize_Clearinghouse2_T_c2_19

typedef Clearinghouse2_StreamOfObjectName StreamOfObjectName;
#define sizeof_StreamOfObjectName sizeof_Clearinghouse2_StreamOfObjectName
#define clear_StreamOfObjectName clear_Clearinghouse2_StreamOfObjectName
#define externalize_StreamOfObjectName externalize_Clearinghouse2_StreamOfObjectName
#define internalize_StreamOfObjectName internalize_Clearinghouse2_StreamOfObjectName

typedef Clearinghouse2_T_r2_21 T_r2_21;
#define sizeof_T_r2_21 sizeof_Clearinghouse2_T_r2_21
#define clear_T_r2_21 clear_Clearinghouse2_T_r2_21
#define externalize_T_r2_21 externalize_Clearinghouse2_T_r2_21
#define internalize_T_r2_21 internalize_Clearinghouse2_T_r2_21

typedef Clearinghouse2_T_c2_20 T_c2_20;
#define sizeof_T_c2_20 sizeof_Clearinghouse2_T_c2_20
#define clear_T_c2_20 clear_Clearinghouse2_T_c2_20
#define externalize_T_c2_20 externalize_Clearinghouse2_T_c2_20
#define internalize_T_c2_20 internalize_Clearinghouse2_T_c2_20

typedef Clearinghouse2_T_c2_22 T_c2_22;
#define sizeof_T_c2_22 sizeof_Clearinghouse2_T_c2_22
#define clear_T_c2_22 clear_Clearinghouse2_T_c2_22
#define externalize_T_c2_22 externalize_Clearinghouse2_T_c2_22
#define internalize_T_c2_22 internalize_Clearinghouse2_T_c2_22

typedef Clearinghouse2_StreamOfOrganization StreamOfOrganization;
#define sizeof_StreamOfOrganization sizeof_Clearinghouse2_StreamOfOrganization
#define clear_StreamOfOrganization clear_Clearinghouse2_StreamOfOrganization
#define externalize_StreamOfOrganization externalize_Clearinghouse2_StreamOfOrganization
#define internalize_StreamOfOrganization internalize_Clearinghouse2_StreamOfOrganization

typedef Clearinghouse2_T_r2_24 T_r2_24;
#define sizeof_T_r2_24 sizeof_Clearinghouse2_T_r2_24
#define clear_T_r2_24 clear_Clearinghouse2_T_r2_24
#define externalize_T_r2_24 externalize_Clearinghouse2_T_r2_24
#define internalize_T_r2_24 internalize_Clearinghouse2_T_r2_24

typedef Clearinghouse2_T_c2_23 T_c2_23;
#define sizeof_T_c2_23 sizeof_Clearinghouse2_T_c2_23
#define clear_T_c2_23 clear_Clearinghouse2_T_c2_23
#define externalize_T_c2_23 externalize_Clearinghouse2_T_c2_23
#define internalize_T_c2_23 internalize_Clearinghouse2_T_c2_23

typedef Clearinghouse2_T_c2_25 T_c2_25;
#define sizeof_T_c2_25 sizeof_Clearinghouse2_T_c2_25
#define clear_T_c2_25 clear_Clearinghouse2_T_c2_25
#define externalize_T_c2_25 externalize_Clearinghouse2_T_c2_25
#define internalize_T_c2_25 internalize_Clearinghouse2_T_c2_25

typedef Clearinghouse2_StreamOfThreePartName StreamOfThreePartName;
#define sizeof_StreamOfThreePartName sizeof_Clearinghouse2_StreamOfThreePartName
#define clear_StreamOfThreePartName clear_Clearinghouse2_StreamOfThreePartName
#define externalize_StreamOfThreePartName externalize_Clearinghouse2_StreamOfThreePartName
#define internalize_StreamOfThreePartName internalize_Clearinghouse2_StreamOfThreePartName

typedef Clearinghouse2_Property Property;
#define sizeof_Property sizeof_Clearinghouse2_Property
#define clear_Property clear_Clearinghouse2_Property
#define externalize_Property externalize_Clearinghouse2_Property
#define internalize_Property internalize_Clearinghouse2_Property

typedef Clearinghouse2_Properties Properties;
#define sizeof_Properties sizeof_Clearinghouse2_Properties
#define clear_Properties clear_Clearinghouse2_Properties
#define externalize_Properties externalize_Clearinghouse2_Properties
#define internalize_Properties internalize_Clearinghouse2_Properties

#define all Clearinghouse2_all
#define nullProperty Clearinghouse2_nullProperty
typedef Clearinghouse2_Item Item;
#define sizeof_Item sizeof_Clearinghouse2_Item
#define clear_Item clear_Clearinghouse2_Item
#define externalize_Item externalize_Clearinghouse2_Item
#define internalize_Item internalize_Clearinghouse2_Item

typedef Clearinghouse2_T_r2_26 T_r2_26;
#define sizeof_T_r2_26 sizeof_Clearinghouse2_T_r2_26
#define clear_T_r2_26 clear_Clearinghouse2_T_r2_26
#define externalize_T_r2_26 externalize_Clearinghouse2_T_r2_26
#define internalize_T_r2_26 internalize_Clearinghouse2_T_r2_26

typedef Clearinghouse2_T_r2_27 T_r2_27;
#define sizeof_T_r2_27 sizeof_Clearinghouse2_T_r2_27
#define clear_T_r2_27 clear_Clearinghouse2_T_r2_27
#define externalize_T_r2_27 externalize_Clearinghouse2_T_r2_27
#define internalize_T_r2_27 internalize_Clearinghouse2_T_r2_27

typedef Clearinghouse2_NetworkAddress NetworkAddress;
#define sizeof_NetworkAddress sizeof_Clearinghouse2_NetworkAddress
#define clear_NetworkAddress clear_Clearinghouse2_NetworkAddress
#define externalize_NetworkAddress externalize_Clearinghouse2_NetworkAddress
#define internalize_NetworkAddress internalize_Clearinghouse2_NetworkAddress

typedef Clearinghouse2_NetworkAddressList NetworkAddressList;
#define sizeof_NetworkAddressList sizeof_Clearinghouse2_NetworkAddressList
#define clear_NetworkAddressList clear_Clearinghouse2_NetworkAddressList
#define externalize_NetworkAddressList externalize_Clearinghouse2_NetworkAddressList
#define internalize_NetworkAddressList internalize_Clearinghouse2_NetworkAddressList

typedef Clearinghouse2_Authenticator Authenticator;
#define sizeof_Authenticator sizeof_Clearinghouse2_Authenticator
#define clear_Authenticator clear_Clearinghouse2_Authenticator
#define externalize_Authenticator externalize_Clearinghouse2_Authenticator
#define internalize_Authenticator internalize_Clearinghouse2_Authenticator

#define wildcard Clearinghouse2_wildcard
typedef Clearinghouse2_WhichArgument WhichArgument;
#define sizeof_WhichArgument sizeof_Clearinghouse2_WhichArgument
#define clear_WhichArgument clear_Clearinghouse2_WhichArgument
#define externalize_WhichArgument externalize_Clearinghouse2_WhichArgument
#define internalize_WhichArgument internalize_Clearinghouse2_WhichArgument

typedef Clearinghouse2_ArgumentProblem ArgumentProblem;
#define sizeof_ArgumentProblem sizeof_Clearinghouse2_ArgumentProblem
#define clear_ArgumentProblem clear_Clearinghouse2_ArgumentProblem
#define externalize_ArgumentProblem externalize_Clearinghouse2_ArgumentProblem
#define internalize_ArgumentProblem internalize_Clearinghouse2_ArgumentProblem

#define ArgumentError Clearinghouse2_ArgumentError
#define ArgumentErrorArgs Clearinghouse2_ArgumentErrorArgs
#define AuthenticationError Clearinghouse2_AuthenticationError
#define AuthenticationErrorArgs Clearinghouse2_AuthenticationErrorArgs
typedef Clearinghouse2_CallProblem CallProblem;
#define sizeof_CallProblem sizeof_Clearinghouse2_CallProblem
#define clear_CallProblem clear_Clearinghouse2_CallProblem
#define externalize_CallProblem externalize_Clearinghouse2_CallProblem
#define internalize_CallProblem internalize_Clearinghouse2_CallProblem

#define CallError Clearinghouse2_CallError
#define CallErrorArgs Clearinghouse2_CallErrorArgs
typedef Clearinghouse2_PropertyProblem PropertyProblem;
#define sizeof_PropertyProblem sizeof_Clearinghouse2_PropertyProblem
#define clear_PropertyProblem clear_Clearinghouse2_PropertyProblem
#define externalize_PropertyProblem externalize_Clearinghouse2_PropertyProblem
#define internalize_PropertyProblem internalize_Clearinghouse2_PropertyProblem

#define PropertyError Clearinghouse2_PropertyError
#define PropertyErrorArgs Clearinghouse2_PropertyErrorArgs
typedef Clearinghouse2_UpdateProblem UpdateProblem;
#define sizeof_UpdateProblem sizeof_Clearinghouse2_UpdateProblem
#define clear_UpdateProblem clear_Clearinghouse2_UpdateProblem
#define externalize_UpdateProblem externalize_Clearinghouse2_UpdateProblem
#define internalize_UpdateProblem internalize_Clearinghouse2_UpdateProblem

#define UpdateError Clearinghouse2_UpdateError
#define UpdateErrorArgs Clearinghouse2_UpdateErrorArgs
#define WrongServer Clearinghouse2_WrongServer
#define WrongServerArgs Clearinghouse2_WrongServerArgs
#define CreateObject Clearinghouse2_CreateObject
#define DeleteObject Clearinghouse2_DeleteObject
#define LookupObject Clearinghouse2_LookupObject
typedef Clearinghouse2_LookupObjectResults LookupObjectResults;
#define sizeof_LookupObjectResults sizeof_Clearinghouse2_LookupObjectResults
#define clear_LookupObjectResults clear_Clearinghouse2_LookupObjectResults
#define externalize_LookupObjectResults externalize_Clearinghouse2_LookupObjectResults
#define internalize_LookupObjectResults internalize_Clearinghouse2_LookupObjectResults

#define ListOrganizations Clearinghouse2_ListOrganizations
#define ListDomain Clearinghouse2_ListDomain
#define ListObjects Clearinghouse2_ListObjects
#define ListAliasesOf Clearinghouse2_ListAliasesOf
typedef Clearinghouse2_ListAliasesOfResults ListAliasesOfResults;
#define sizeof_ListAliasesOfResults sizeof_Clearinghouse2_ListAliasesOfResults
#define clear_ListAliasesOfResults clear_Clearinghouse2_ListAliasesOfResults
#define externalize_ListAliasesOfResults externalize_Clearinghouse2_ListAliasesOfResults
#define internalize_ListAliasesOfResults internalize_Clearinghouse2_ListAliasesOfResults

#define CreateAlias Clearinghouse2_CreateAlias
typedef Clearinghouse2_CreateAliasResults CreateAliasResults;
#define sizeof_CreateAliasResults sizeof_Clearinghouse2_CreateAliasResults
#define clear_CreateAliasResults clear_Clearinghouse2_CreateAliasResults
#define externalize_CreateAliasResults externalize_Clearinghouse2_CreateAliasResults
#define internalize_CreateAliasResults internalize_Clearinghouse2_CreateAliasResults

#define DeleteAlias Clearinghouse2_DeleteAlias
typedef Clearinghouse2_DeleteAliasResults DeleteAliasResults;
#define sizeof_DeleteAliasResults sizeof_Clearinghouse2_DeleteAliasResults
#define clear_DeleteAliasResults clear_Clearinghouse2_DeleteAliasResults
#define externalize_DeleteAliasResults externalize_Clearinghouse2_DeleteAliasResults
#define internalize_DeleteAliasResults internalize_Clearinghouse2_DeleteAliasResults

#define ListAliases Clearinghouse2_ListAliases
#define DeleteProperty Clearinghouse2_DeleteProperty
typedef Clearinghouse2_DeletePropertyResults DeletePropertyResults;
#define sizeof_DeletePropertyResults sizeof_Clearinghouse2_DeletePropertyResults
#define clear_DeletePropertyResults clear_Clearinghouse2_DeletePropertyResults
#define externalize_DeletePropertyResults externalize_Clearinghouse2_DeletePropertyResults
#define internalize_DeletePropertyResults internalize_Clearinghouse2_DeletePropertyResults

#define ListProperties Clearinghouse2_ListProperties
typedef Clearinghouse2_ListPropertiesResults ListPropertiesResults;
#define sizeof_ListPropertiesResults sizeof_Clearinghouse2_ListPropertiesResults
#define clear_ListPropertiesResults clear_Clearinghouse2_ListPropertiesResults
#define externalize_ListPropertiesResults externalize_Clearinghouse2_ListPropertiesResults
#define internalize_ListPropertiesResults internalize_Clearinghouse2_ListPropertiesResults

#define AddItemProperty Clearinghouse2_AddItemProperty
typedef Clearinghouse2_AddItemPropertyResults AddItemPropertyResults;
#define sizeof_AddItemPropertyResults sizeof_Clearinghouse2_AddItemPropertyResults
#define clear_AddItemPropertyResults clear_Clearinghouse2_AddItemPropertyResults
#define externalize_AddItemPropertyResults externalize_Clearinghouse2_AddItemPropertyResults
#define internalize_AddItemPropertyResults internalize_Clearinghouse2_AddItemPropertyResults

#define RetrieveItem Clearinghouse2_RetrieveItem
typedef Clearinghouse2_RetrieveItemResults RetrieveItemResults;
#define sizeof_RetrieveItemResults sizeof_Clearinghouse2_RetrieveItemResults
#define clear_RetrieveItemResults clear_Clearinghouse2_RetrieveItemResults
#define externalize_RetrieveItemResults externalize_Clearinghouse2_RetrieveItemResults
#define internalize_RetrieveItemResults internalize_Clearinghouse2_RetrieveItemResults

#define ChangeItem Clearinghouse2_ChangeItem
typedef Clearinghouse2_ChangeItemResults ChangeItemResults;
#define sizeof_ChangeItemResults sizeof_Clearinghouse2_ChangeItemResults
#define clear_ChangeItemResults clear_Clearinghouse2_ChangeItemResults
#define externalize_ChangeItemResults externalize_Clearinghouse2_ChangeItemResults
#define internalize_ChangeItemResults internalize_Clearinghouse2_ChangeItemResults

#define AddGroupProperty Clearinghouse2_AddGroupProperty
typedef Clearinghouse2_AddGroupPropertyResults AddGroupPropertyResults;
#define sizeof_AddGroupPropertyResults sizeof_Clearinghouse2_AddGroupPropertyResults
#define clear_AddGroupPropertyResults clear_Clearinghouse2_AddGroupPropertyResults
#define externalize_AddGroupPropertyResults externalize_Clearinghouse2_AddGroupPropertyResults
#define internalize_AddGroupPropertyResults internalize_Clearinghouse2_AddGroupPropertyResults

#define RetrieveMembers Clearinghouse2_RetrieveMembers
typedef Clearinghouse2_RetrieveMembersResults RetrieveMembersResults;
#define sizeof_RetrieveMembersResults sizeof_Clearinghouse2_RetrieveMembersResults
#define clear_RetrieveMembersResults clear_Clearinghouse2_RetrieveMembersResults
#define externalize_RetrieveMembersResults externalize_Clearinghouse2_RetrieveMembersResults
#define internalize_RetrieveMembersResults internalize_Clearinghouse2_RetrieveMembersResults

#define AddMember Clearinghouse2_AddMember
typedef Clearinghouse2_AddMemberResults AddMemberResults;
#define sizeof_AddMemberResults sizeof_Clearinghouse2_AddMemberResults
#define clear_AddMemberResults clear_Clearinghouse2_AddMemberResults
#define externalize_AddMemberResults externalize_Clearinghouse2_AddMemberResults
#define internalize_AddMemberResults internalize_Clearinghouse2_AddMemberResults

#define AddSelf Clearinghouse2_AddSelf
typedef Clearinghouse2_AddSelfResults AddSelfResults;
#define sizeof_AddSelfResults sizeof_Clearinghouse2_AddSelfResults
#define clear_AddSelfResults clear_Clearinghouse2_AddSelfResults
#define externalize_AddSelfResults externalize_Clearinghouse2_AddSelfResults
#define internalize_AddSelfResults internalize_Clearinghouse2_AddSelfResults

#define DeleteMember Clearinghouse2_DeleteMember
typedef Clearinghouse2_DeleteMemberResults DeleteMemberResults;
#define sizeof_DeleteMemberResults sizeof_Clearinghouse2_DeleteMemberResults
#define clear_DeleteMemberResults clear_Clearinghouse2_DeleteMemberResults
#define externalize_DeleteMemberResults externalize_Clearinghouse2_DeleteMemberResults
#define internalize_DeleteMemberResults internalize_Clearinghouse2_DeleteMemberResults

#define DeleteSelf Clearinghouse2_DeleteSelf
typedef Clearinghouse2_DeleteSelfResults DeleteSelfResults;
#define sizeof_DeleteSelfResults sizeof_Clearinghouse2_DeleteSelfResults
#define clear_DeleteSelfResults clear_Clearinghouse2_DeleteSelfResults
#define externalize_DeleteSelfResults externalize_Clearinghouse2_DeleteSelfResults
#define internalize_DeleteSelfResults internalize_Clearinghouse2_DeleteSelfResults

#define IsMember Clearinghouse2_IsMember
typedef Clearinghouse2_IsMemberResults IsMemberResults;
#define sizeof_IsMemberResults sizeof_Clearinghouse2_IsMemberResults
#define clear_IsMemberResults clear_Clearinghouse2_IsMemberResults
#define externalize_IsMemberResults externalize_Clearinghouse2_IsMemberResults
#define internalize_IsMemberResults internalize_Clearinghouse2_IsMemberResults

#define RetrieveAddresses Clearinghouse2_RetrieveAddresses
typedef Clearinghouse2_RetrieveAddressesResults RetrieveAddressesResults;
#define sizeof_RetrieveAddressesResults sizeof_Clearinghouse2_RetrieveAddressesResults
#define clear_RetrieveAddressesResults clear_Clearinghouse2_RetrieveAddressesResults
#define externalize_RetrieveAddressesResults externalize_Clearinghouse2_RetrieveAddressesResults
#define internalize_RetrieveAddressesResults internalize_Clearinghouse2_RetrieveAddressesResults

#define ListDomainServed Clearinghouse2_ListDomainServed
